﻿using System;
using System.Drawing;
using log4net;
using Syncfusion.HtmlConverter;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        Convert("http://www.yahoo.ca");
    }

    private void Convert(string url)
    {
        string key = Guid.NewGuid().ToString();
        Log.Debug(String.Format("{0}: started", key));
        PdfDocument doc = new PdfDocument();
        try
        {
            doc.PageSettings.Orientation = PdfPageOrientation.Portrait;
            PdfPage page = doc.Pages.Add();
            SizeF pageSize = page.GetClientSize();
            PdfUnitConvertor convertor = new PdfUnitConvertor();
            float width = convertor.ConvertToPixels(page.GetClientSize().Width, PdfGraphicsUnit.Point);
            Log.Debug(String.Format("{0}: getting html", key));
            using (HtmlConverter htmlconverter = new HtmlConverter())
            {
                Image img = htmlconverter.ConvertToImage(url, ImageType.Metafile, (int)width, -1, AspectRatio.KeepWidth);
                PdfMetafile metafile = (PdfMetafile)PdfImage.FromImage(img);
                PdfMetafileLayoutFormat format = new PdfMetafileLayoutFormat();
                format.Break = PdfLayoutBreakType.FitPage;
                format.Layout = PdfLayoutType.Paginate;
                format.SplitTextLines = false;
                doc.PageSettings.Height = img.Height;
                Log.Debug(String.Format("{0}: drawing", key));
                metafile.Draw(page, new RectangleF(0, 0, pageSize.Width, -1), format);
            }
            Log.Debug(String.Format("{0}: saving", key));
            doc.Save(@"C:\Pdfs\" + Guid.NewGuid() + ".pdf");
            Log.Debug(String.Format("{0}: done", key));
        }
        catch (Exception ex)
        {
            Log.Error(String.Format("Exception occured: {0}", ex.Message), ex);
        }
        doc.Close();
    }

    private static readonly ILog Log = LogManager.GetLogger("Test");
}
